#ifndef _OUTPUT_H_
#   define _OUTPUT_H_

#include <stdio.h>
#include <string>

using std::string;

class Output
{
   public:

      Output() {}

      virtual void write(string s)        = 0;
      virtual void writeVerbose(string s) = 0;

      virtual ~Output() {}

   private:
      Output(const Output &);
      Output &operator=(const Output &);
};

class OutputToConsole : public Output
{
   public:
      OutputToConsole(int verbose);

      void write(string s);
      void writeVerbose(string s);

   private:
      int mVerbose;
};

class OutputToFile : public Output
{
   public:
      OutputToFile(int verbose, string fileName);

      void write(string s);
      void writeVerbose(string s);

   private:
      OutputToFile(int verbose, FILE *handle);

      int mVerbose;
      string mFileName;
};

class OutputTee : public Output
{
   public:
      OutputTee(Output *first, Output *second);

      void write(string s);
      void writeVerbose(string s);

      ~OutputTee();

   private:
      Output *mFirst;
      Output *mSecond;
};

#endif
