#ifndef _REGEX_H_
#define _REGEX_H_

#include <vector>
#include <string>

using std::vector;
using std::string;

struct Entry
{
   vector<string> mStrings;
   vector<int>    mOffsets;
};

typedef vector<Entry> EntryVector;

class Regex
{
   public:
      // -----------------------------------
      // Returns:
      //    - true  : a match was found
      //    - false : other
      //
      // In event of an actual error, errMsg
      // will contain a description of
      // the error.  Normally (returning
      // false because of a non-match)
      // errMsg will be empty.
      // -----------------------------------

      static int match(
         const char *pattern,
         int ignoreCase,
         const char *target,
         EntryVector &instances,
         string &errMsg
      );
      
   private:
      Regex();
      Regex(const Regex &);
      Regex &operator=(const Regex &);
};
#endif
