#ifndef _UTIL_H_
#   define _UTIL_H_

#include <string>
#include <vector>

using std::string;
using std::vector;

#define USZ(x) ( sizeof(x) / sizeof(x[0]) )

#define UMK do { printf("[%s|%d]\n", __FILE__, __LINE__); } while(0)

#define UPR(x) do { printf(#x ": [%s]\n", ##x.c_str()); } while(0)

class Util
{
   public:
      static void bail(string errMsg);

      static string getTimeStamp();

      static string toLowerCase(string s);

      static string ltrim(string s);
      static string rtrim(string s);

      static string trim(string s);

      static string lpad(string value, int length);
      static string rpad(string value, int length);

      static string substring(string s, int offset, int nChars);
      static string substring(string s, int offset);

      static vector<string> split(string s, char ch);

      static string toString(const char *fmt, int value);
      static string toString(int value);
      static string toString(__int64 value);

      static string toString(const char *fmt, double value);
      static string toString(double value);

      static int startsWith(string theString, string lookFor);
      static int endsWith(string theString, string lookFor);
      static int indexOf(string theString, char ch);
      static int lastIndexOf(string theString, char ch);
      static int count(string theString, char ch);

      static int imatch(string s1, string s2);

      static string empty();

      static int isEmpty(string s);

   private:
      Util();
};

#endif
